/*
 * ImgAppl.java
 *
 * Created on 30. duben 2007, 19:05
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package animace;

/**
 *
 * @author balikm1
 */

import java.awt.*;

public class ImgAppl extends java.applet.Applet implements Runnable {
    int frame;
    int delay;
    Thread animator;

    Dimension offDimension;
    Image offImage;
    Graphics offGraphics;

    Image frames[];
    String text = "";

    // inicializace
    @Override
    public void init() {
        // ukazka predani parametru - zobrazeny text
	text = getParameter("text");
        if (text == null) text = "";
	delay = 100;

	frames = new Image[10];
	for (int i = 1 ; i <= 10 ; i++) {
	    frames[i-1] = getImage(getCodeBase(), "data/T" + i + ".gif");
	}
    }

    // metoda start volana pri zobrazeni appletu na obrazovce
    // vytvoreni a spusteni vlakna
    @Override
    public void start() {
	animator = new Thread(this);
	animator.start();
    }

    // metoda run volana vlaknem - vlastni cyklus animace
    public void run() {
	while (Thread.currentThread() == animator) {
	    // prekresli snimek
	    repaint();

	    try {
		Thread.sleep(delay);
	    } catch (InterruptedException e) {
		break;
	    }

	    // prejdi na dalsi snimek
	    frame = (frame + 1)%10;
	}
    }

    // volana, kdyz applet prestane byt zobrazovan
    // nastavi promennou "animator" na null aby se vlakno pred dalsim zobrazovanim ukoncilo
    @Override
    public void stop() {
	animator = null;
	offImage = null;
	offGraphics = null;
    }

    // update animace
    // vyvolana prikazem repaint()
    // pretezujeme stastandardni implementaci - smazani plochy a volani paint()
    @Override
    public void update(Graphics g) {
	Dimension d = getSize();

	// vytvori graficky kontext pro vykreslovani na pozadi
	if ((offGraphics == null)
	 || (d.width != offDimension.width)
	 || (d.height != offDimension.height)) {
	    offDimension = d;
	    offImage = createImage(d.width, d.height);
	    offGraphics = offImage.getGraphics();
	}

	// smazu predchozi obraz
	offGraphics.setColor(getBackground());
	offGraphics.fillRect(0, 0, d.width, d.height);
	offGraphics.setColor(Color.black);

	// vykreslim vse do obrazku
	paintFrame(offGraphics);

	// vykreslim obrazek na obrazovku
	g.drawImage(offImage, 0, 0, null);
    }

    // vykresleni pri systemem vynucenem prekresleni
    @Override
    public void paint(Graphics g) {
	update(g);
    }

    // vykresleni snimku animace
    public void paintFrame(Graphics g) {
	g.drawImage(frames[frame], 0, 0, null);
        g.drawChars(text.toCharArray(), 0, text.length(), 100, 100);
    }
}
